-- author: DD ModPassion
-- date: 22.11.2021
-- copyright (C): DD ModPassion, All Rights Reserved
-- version: Farming Simulator 22
GreaseAddon = {} local modDirectory = g_currentModDirectory or "unknown" function GreaseAddon.prerequisitesPresent(specializations) return SpecializationUtil.hasSpecialization(FillUnit, specializations) and SpecializationUtil.hasSpecialization(Cylindered, specializations) and SpecializationUtil.hasSpecialization(Attachable, specializations) end function GreaseAddon.registerOverwrittenFunctions(vehicleType) SpecializationUtil.registerOverwrittenFunction(vehicleType, "updateDamageAmount", GreaseAddon.updateDamageAmount) end function GreaseAddon.initSpecialization() local schema = Vehicle.xmlSchema schema:setXMLSpecializationType("GreaseAddon") schema:register(XMLValueType.NODE_INDEX, "vehicle.cylindered.skfLincoln(?)#linkNode", "SkfLincoln linkNode") schema:register(XMLValueType.NODE_INDEX, "vehicle.cylindered.skfLincoln(?)#storeNode", "SkfLincoln storeNode") schema:register(XMLValueType.INT, "vehicle.cylindered.skfLincoln(?)#usageFactor", "SkfLincoln usageFactor") schema:register(XMLValueType.INT, "vehicle.cylindered.skfLincoln(?)#usageSecond", "SkfLincoln usageSecond") schema:register(XMLValueType.BOOL, "vehicle.cylindered.skfLincoln(?)#trailerTool", "SkfLincoln trailerTool") schema:register(XMLValueType.INT, "vehicle.cylindered.skfLincoln(?).trailer(?)#greaseFittings", "Current greaseFittings value") schema:register(XMLValueType.INT, "vehicle.cylindered.skfLincoln(?).dischargeable(?)#greaseFittings", "Current greaseFittings value") schema:register(XMLValueType.INT, "vehicle.cylindered.skfLincoln(?).turnOnVehicle(?)#greaseFittings", "Current greaseFittings value") schema:register(XMLValueType.INT, "vehicle.cylindered.skfLincoln(?).sprayer(?)#greaseFittings", "Current greaseFittings value") SoundManager.registerSampleXMLPaths(schema, "vehicle.cylindered.skfLincoln(?)", "hydraulicWear") schema:setXMLSpecializationType() local schemaSavegame = Vehicle.xmlSchemaSavegame schemaSavegame:register(XMLValueType.INT, "vehicles.vehicle(?).cylindered.skfLincoln(?).trailer(?)#greaseFittings", "Current greaseFittings value") schemaSavegame:register(XMLValueType.INT, "vehicles.vehicle(?).cylindered.skfLincoln(?).dischargeable(?)#greaseFittings", "Current greaseFittings value") schemaSavegame:register(XMLValueType.INT, "vehicles.vehicle(?).cylindered.skfLincoln(?).turnOnVehicle(?)#greaseFittings", "Current greaseFittings value") schemaSavegame:register(XMLValueType.INT, "vehicles.vehicle(?).cylindered.skfLincoln(?).sprayer(?)#greaseFittings", "Current greaseFittings value") end function GreaseAddon.registerFunctions(vehicleType) SpecializationUtil.registerFunction(vehicleType, "getTurnedState", GreaseAddon.getTurnedState) end function GreaseAddon.registerEventListeners(vehicleType) SpecializationUtil.registerEventListener(vehicleType, "onLoad", GreaseAddon) SpecializationUtil.registerEventListener(vehicleType, "onUpdate", GreaseAddon) SpecializationUtil.registerEventListener(vehicleType, "onDraw", GreaseAddon) SpecializationUtil.registerEventListener(vehicleType, "onPostAttach", GreaseAddon) SpecializationUtil.registerEventListener(vehicleType, "onPreDetach", GreaseAddon) end function GreaseAddon:onLoad(savegame) local spec = self.spec_fillUnit spec.attachedTrailer = nil spec.attachedTrailerTool = nil spec.greaseType = {} spec.greaseTypeWork = 1 spec.greaseTypeDischarge = 2 spec.greaseTypeTurned = 3 spec.greaseTypeSprayer = 4 spec.turnedState = false spec.isHydraulicWearPlaying = false spec.isInitializedGrease = true local key = string.format("vehicle.cylindered.skfLincoln(0)") if self.xmlFile:hasProperty(key) then spec.usageFactor = Utils.getNoNil(self.xmlFile:getValue(key.."#usageFactor"), 1)/1000 spec.usageSecond = Utils.getNoNil(self.xmlFile:getValue(key.."#usageSecond"), 30) spec.trailerTool = Utils.getNoNil(self.xmlFile:getValue(key.."#trailerTool"), false) local entry = {} entry.workTime = 0 local trailer = string.format("%s.trailer(0)", key) entry.fittings = Utils.getNoNil(self.xmlFile:getValue(trailer.."#greaseFittings"), 0) table.insert(spec.greaseType, entry) local entry = {} entry.workTime = 0 local dischargeable = string.format("%s.dischargeable(0)", key) entry.fittings = Utils.getNoNil(self.xmlFile:getValue(dischargeable.."#greaseFittings"), 0) table.insert(spec.greaseType, entry) local entry = {} entry.workTime = 0 local turnOnVehicle = string.format("%s.turnOnVehicle(0)", key) entry.fittings = Utils.getNoNil(self.xmlFile:getValue(turnOnVehicle.."#greaseFittings"), 0) table.insert(spec.greaseType, entry) local entry = {} entry.workTime = 0 local sprayer = string.format("%s.sprayer(0)", key) entry.fittings = Utils.getNoNil(self.xmlFile:getValue(sprayer.."#greaseFittings"), 0) table.insert(spec.greaseType, entry) spec.skfLincoln = {} if not spec.trailerTool then local i3dFilename = Utils.getFilename("filename/skfLincoln.i3d", modDirectory) spec.skfLincoln.linkNode = self.xmlFile:getValue(key.."#linkNode", nil, self.components, self.i3dMappings) local i3dNode = g_i3DManager:loadSharedI3DFile(i3dFilename, false, false) if i3dNode ~= 0 then spec.skfLincoln.node = I3DUtil.indexToObject(i3dNode, "0") link(spec.skfLincoln.linkNode, spec.skfLincoln.node) spec.skfLincoln.volume = getChildAt(spec.skfLincoln.node, 0) spec.skfLincoln.storeNode = self.xmlFile:getValue(key.."#storeNode", nil, self.components, self.i3dMappings) setVisibility(spec.skfLincoln.storeNode, false) delete(i3dNode) if self.isClient then spec.skfLincoln.hydraulicWear = g_soundManager:loadSampleFromXML(self.xmlFile, key, "hydraulicWear", self.baseDirectory, self.components, 0, AudioGroup.VEHICLE, self.i3dMappings, self) end else spec.isInitializedGrease = false end if Utils.getNoNil(spec.fillUnits[#spec.fillUnits].supportedFillTypes[g_fillTypeManager:getFillTypeIndexByName("grease")], false) then spec.greaseFillUnit = #spec.fillUnits else spec.isInitializedGrease = false end else spec.isInitializedGrease = false end else spec.isInitializedGrease = false end end function GreaseAddon:onUpdate(dt, isActiveForInput, isActiveForInputIgnoreSelection, isSelected) local spec = self.spec_fillUnit if spec.isInitializedGrease then if not (g_currentMission.missionInfo.helperBuyFuel and self:getIsAIActive()) then if self:getFillUnitFillLevel(spec.greaseFillUnit) > 0 then if self.lastSpeedReal*1000 > 0.9 then spec.greaseType[spec.greaseTypeWork].workTime = dt/1000 + spec.greaseType[spec.greaseTypeWork].workTime end if self:getTurnedState() then spec.greaseType[spec.greaseTypeDischarge].workTime = dt/1000 + spec.greaseType[spec.greaseTypeDischarge].workTime if spec.turnedState == false then spec.greaseType[spec.greaseTypeTurned].workTime = dt/10 + spec.greaseType[spec.greaseTypeTurned].workTime spec.turnedState = true end if spec.attachedTrailerTool ~= nil then spec.greaseType[spec.greaseTypeSprayer].workTime = dt/1000 + spec.greaseType[spec.greaseTypeSprayer].workTime end else if self.spec_dischargeable ~= nil then if self.spec_dischargeable.currentDischargeState ~= Dischargeable.DISCHARGE_STATE_OFF then spec.greaseType[spec.greaseTypeDischarge].workTime = dt/1000 + spec.greaseType[spec.greaseTypeDischarge].workTime end end spec.turnedState = false end for _, greaseType in ipairs(spec.greaseType) do if greaseType.workTime > spec.usageSecond then local fillDelta = spec.usageFactor*greaseType.fittings self:addFillUnitFillLevel(self:getOwnerFarmId(), spec.greaseFillUnit, -fillDelta, self:getFillUnitFillType(spec.greaseFillUnit), ToolType.UNDEFINED, unloadInfo) greaseType.workTime = 0 end end setScale(spec.skfLincoln.volume, 1, self:getFillUnitFillLevelPercentage(spec.greaseFillUnit), 1) local _, y, _ = getRotation(spec.skfLincoln.volume) setRotation(spec.skfLincoln.volume, 0, y - 0.01, 0) spec.isHydraulicWearPlaying = false elseif self:getFillUnitFillLevel(spec.greaseFillUnit) <= 0 then setScale(spec.skfLincoln.volume, 1, 0.01, 1) if self.isClient and spec.skfLincoln.hydraulicWear ~= nil then if self.spec_dischargeable ~= nil then if self.spec_dischargeable.currentDischargeState ~= Dischargeable.DISCHARGE_STATE_OFF then spec.isHydraulicWearPlaying = true else spec.isHydraulicWearPlaying = false end elseif self:getTurnedState() then spec.isHydraulicWearPlaying = true else spec.isHydraulicWearPlaying = false end end end end if self.isClient and isActiveForInputIgnoreSelection then if self:getFillUnitFillLevel(spec.greaseFillUnit) >= 1 and self.spec_cover.isStateSetAutomatically then g_currentMission:showBlinkingWarning(g_i18n:getText("info_needFillTheGrease", self.customEnvironment)) end end if self.isClient and spec.skfLincoln.hydraulicWear ~= nil then if spec.isHydraulicWearPlaying then g_soundManager:playSample(spec.skfLincoln.hydraulicWear) else g_soundManager:stopSample(spec.skfLincoln.hydraulicWear) end end end end function GreaseAddon:updateDamageAmount(superFunc, dt) local spec = self.spec_wearable if self:getUsageCausesDamage() then local factor = 1 if self.lifetime ~= nil and self.lifetime ~= 0 then local ageMultiplier = 0.3 * math.min(self.age / self.lifetime, 1) local operatingTime = self.operatingTime / 3600000 local operatingTimeMultiplier = 0.7 * math.min(operatingTime / (self.lifetime * EconomyManager.LIFETIME_OPERATINGTIME_RATIO), 1) factor = 1 + EconomyManager.MAX_DAILYUPKEEP_MULTIPLIER * (ageMultiplier + operatingTimeMultiplier) end if self.spec_fillUnit.isInitializedGrease then if self:getFillUnitFillLevel(self.spec_fillUnit.greaseFillUnit) <= 0 then factor = factor * 2 end end return dt * spec.wearDuration * 0.5 * factor else return 0 end end function GreaseAddon:onDraw(isActiveForInput, isActiveForInputIgnoreSelection, isSelected) local spec = self.spec_fillUnit if isActiveForInputIgnoreSelection and spec.isInitializedGrease then if self:getFillUnitFillLevel(spec.greaseFillUnit) <= 0 then g_currentMission:addExtraPrintText(g_i18n:getText("info_firstFillTheGrease", self.customEnvironment)) end end end function GreaseAddon:onPostAttach(attacherVehicle, inputJointDescIndex, jointDescIndex, loadFromSavegame) local spec = self.spec_fillUnit if spec.trailerTool and spec.isInitializedGrease then spec.attachedTrailer = self:getAttacherVehicle() if spec.attachedTrailer.spec_fillUnit ~= nil then local attachedTrailerisValid = 0 if spec.greaseType[spec.greaseTypeTurned].fittings ~= nil then spec.attachedTrailer.spec_fillUnit.greaseType[spec.greaseTypeTurned].fittings = spec.attachedTrailer.spec_fillUnit.greaseType[spec.greaseTypeTurned].fittings + spec.greaseType[spec.greaseTypeTurned].fittings attachedTrailerisValid = attachedTrailerisValid + 1 end if spec.greaseType[spec.greaseTypeSprayer].fittings ~= nil then spec.attachedTrailer.spec_fillUnit.greaseType[spec.greaseTypeSprayer].fittings = spec.attachedTrailer.spec_fillUnit.greaseType[spec.greaseTypeSprayer].fittings + spec.greaseType[spec.greaseTypeSprayer].fittings attachedTrailerisValid = attachedTrailerisValid + 1 end if attachedTrailerisValid > 1 then spec.attachedTrailer.spec_fillUnit.attachedTrailerTool = self else spec.attachedTrailer.spec_fillUnit.attachedTrailerTool = nil end end end end function GreaseAddon:onPreDetach(attacherVehicle, implement) local spec = self.spec_fillUnit if spec.attachedTrailer ~= nil and spec.isInitializedGrease then if spec.attachedTrailer.spec_fillUnit ~= nil then spec.attachedTrailer.spec_fillUnit.greaseType[spec.greaseTypeTurned].fittings = spec.attachedTrailer.spec_fillUnit.greaseType[spec.greaseTypeTurned].fittings - spec.greaseType[spec.greaseTypeTurned].fittings spec.attachedTrailer.spec_fillUnit.greaseType[spec.greaseTypeSprayer].fittings = spec.attachedTrailer.spec_fillUnit.greaseType[spec.greaseTypeSprayer].fittings - spec.greaseType[spec.greaseTypeSprayer].fittings spec.attachedTrailer.spec_fillUnit.attachedTrailerTool = nil spec.attachedTrailer = nil end end end function GreaseAddon:getTurnedState() local spec = self.spec_turnOnVehicle if spec == nil then return false else return spec.isAlwaysTurnedOn or spec.isTurnedOn end end function GreaseAddon:updateDebugValues(values) local spec = self.spec_fillUnit if self:getFillUnitExists(spec.greaseFillUnit) and spec.isInitializedGrease then table.insert(values, {name="isHydraulicWearPlaying", value=spec.isHydraulicWearPlaying}) table.insert(values, {name="greaseTypeWork.workTime", value=string.format("%.4f", spec.greaseType[spec.greaseTypeWork].workTime)}) table.insert(values, {name="greaseTypeDischarge.workTime", value=string.format("%.4f", spec.greaseType[spec.greaseTypeDischarge].workTime)}) table.insert(values, {name="greaseTypeTurned.workTime", value=string.format("%.4f", spec.greaseType[spec.greaseTypeTurned].workTime)}) table.insert(values, {name="greaseTypeSprayer.workTime", value=string.format("%.4f", spec.greaseType[spec.greaseTypeSprayer].workTime)}) table.insert(values, {name="greaseFillUnit", value=string.format("%.4f", self:getFillUnitFillLevel(spec.greaseFillUnit))}) table.insert(values, {name="greaseTypeWork.fittings", value=string.format("%.4f", spec.greaseType[spec.greaseTypeWork].fittings)}) table.insert(values, {name="greaseTypeDischarge.fittings", value=string.format("%.4f", spec.greaseType[spec.greaseTypeDischarge].fittings)}) table.insert(values, {name="greaseTypeTurned.fittings", value=string.format("%.4f", spec.greaseType[spec.greaseTypeTurned].fittings)}) table.insert(values, {name="greaseTypeSprayer.fittings", value=string.format("%.4f", spec.greaseType[spec.greaseTypeSprayer].fittings)}) end end